=== modified file '.bzrignore'
--- .bzrignore	2011-03-10 14:22:12 +0000
+++ .bzrignore	2010-04-22 08:52:59 +0000
@@ -1,5 +1,6 @@
 ./dist
 ./loggerhead.egg-info
+./loggerhead.conf
 ./loggerhead.pid
 ./logs
 build

=== modified file 'MANIFEST.in'
--- MANIFEST.in	2011-03-10 14:22:12 +0000
+++ MANIFEST.in	2008-06-22 18:04:15 +0000
@@ -1,2 +1,2 @@
-include README.txt NEWS
+include loggerhead.conf.example README.txt NEWS
 recursive-include loggerhead/static *

=== modified file 'Makefile'
--- Makefile	2011-03-14 08:47:03 +0000
+++ Makefile	2007-10-29 16:19:30 +0000
@@ -8,4 +8,5 @@
 	rm -rf dist/
 
 check:
-	BZR_PLUGINS_AT=loggerhead@$$(pwd) bzr selftest -s bp.loggerhead
+	# XXX MichaelHudson 2007-10-29 bug=158361: We can't run the loggerhead
+	# tests in PQM yet :(

=== modified file 'NEWS'
--- NEWS	2011-09-08 00:33:28 +0000
+++ NEWS	2011-03-04 15:49:43 +0000
@@ -9,12 +9,6 @@
       multiple threads, and issue concurrent requests.
       (John Arbash Meinel)
 
-    - HEAD requests should not return body content. This is done by adding
-      another wsgi middleware that strips the body when the REQUEST_METHOD is
-      HEAD. Note that you have to add the middleware into your pipeline, and
-      it does not decrease the actual work done.
-      (John Arbash Meinel, #716201)
-
     - If we get a HEAD request, there is no reason to expand the template, we
       shouldn't be returning body content anyway.
       (John Arbash Meinel, #716201, #716217)
@@ -22,37 +16,12 @@
     - Merge the pqm changes back into trunk, after trunk was reverted to an old
       revision. (John Arbash Meinel, #716152)
 
-    - Redirect ``/files/file.txt`` to ``/view/file.txt`` and ``/view/dir`` to
-      ``/files/dir``. (Jasper St. Pierre, #569358)
+    - The json module is no longer claimed to be supported as alternative for 
+      simplejson. (Jelmer Vernooij, #586611)
 
     - Remove ``start-loggerhead`` and ``stop-loggerhead`` which were already
       deprecated. (John Arbash Meinel)
 
-    - Show "Author(s)" as separate from "Committer". And label them
-      correctly. (John Arbash Meinel, #733015)
-
-    - The json module is no longer claimed to be supported as alternative for 
-      simplejson. (Jelmer Vernooij, #586611)
-
-    - Viewing the ``/changes`` page only iterates enough of the history to show
-      the actual revisions displayed, rather than walking the whole mainline.
-      Improves performance on projects with long histories like emacs.
-      (John Arbash Meinel)
-
-    - Fix support for displaying foreign revision ids.
-      (Jelmer Vernooij, #736026)
-
-
-1.18.1 [24Mar2011]
-------------------
-
-    - Fix escaping of filenames in revision views.
-      (William Grant, #740142)
-
-    - Add missing import to loggerhead.trace, allowing start-loggerhead
-      to run when a log.roll config option is set.
-      (Max Kanat-Alexander, #673999)
-
 
 1.18 [10Nov2010]
 ----------------

=== modified file '__init__.py'
--- __init__.py	2011-04-12 10:18:52 +0000
+++ __init__.py	2011-02-10 01:57:32 +0000
@@ -30,8 +30,6 @@
 starts a web server to browse the contents of a branch.
 """
 
-import sys
-
 from info import (
     bzr_plugin_version as version_info,
     bzr_compatible_versions,
@@ -51,6 +49,17 @@
     HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
             (DEFAULT_PORT,))
 
+    def setup_logging(config):
+        import logging
+        import sys
+
+        logger = logging.getLogger('loggerhead')
+        handler = logging.StreamHandler(sys.stderr)
+        handler.setLevel(logging.DEBUG)
+        logger.addHandler(handler)
+        logging.getLogger('simpleTAL').addHandler(handler)
+        logging.getLogger('simpleTALES').addHandler(handler)
+
     def _ensure_loggerhead_path():
         """Ensure that you can 'import loggerhead' and get the root."""
         # loggerhead internal code will try to 'import loggerhead', so
@@ -62,19 +71,13 @@
             sys.path.append(os.path.dirname(__file__))
 
     def serve_http(transport, host=None, port=None, inet=None):
-        # TODO: if we supported inet to pass requests in and respond to them,
-        #       then it would be easier to test the full stack, but it probably
-        #       means routing around paste.httpserver.serve which probably
-        #       isn't testing the full stack
         from paste.httpexceptions import HTTPExceptionHandler
         from paste.httpserver import serve
 
         _ensure_loggerhead_path()
 
-        from loggerhead.apps.http_head import HeadMiddleware
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
-        from loggerhead.main import setup_logging
 
         if host is None:
             host = DEFAULT_HOST
@@ -84,12 +87,8 @@
         if not transport.is_readonly():
             argv.insert(0, '--allow-writes')
         config = LoggerheadConfig(argv)
-        setup_logging(config, init_logging=False, log_file=sys.stderr)
+        setup_logging(config)
         app = BranchesFromTransportRoot(transport.base, config)
-        # Bug #758618, HeadMiddleware seems to break HTTPExceptionHandler from
-        # actually sending appropriate return codes to the client. Since nobody
-        # desperately needs HeadMiddleware right now, just ignoring it.
-        # app = HeadMiddleware(app)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
 

=== added file 'loggerhead.conf.example'
--- loggerhead.conf.example	1970-01-01 00:00:00 +0000
+++ loggerhead.conf.example	2009-10-17 09:28:42 +0000
@@ -0,0 +1,76 @@
+
+# use this to change the server's port
+#server.socket_port = 8080
+
+# use this if you're mapping loggerhead within apache via proxy
+#server.webpath = 'http://example.com/branches'
+
+# use this if you want loggerhead to listen to another interface than 127.0.0.1
+# server.socket_host = 'your_hostname_or_ip'
+
+# where's bzrlib?
+# (you only need this if you don't install bzr.)
+#bzrpath = '/Users/robey/code/bzr/bzr'
+
+# if you want a special title on the front page, set it here:
+title = 'branches in loggerhead'
+
+# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
+log.roll = 'weekly'
+
+# group branches by project:
+[bazaar]
+
+    # name of this project
+    name = 'bazaar'
+
+    # for the top browsing page, you can include a description, in raw HTML.
+    #description = 'Bazaar is a <i>revision control system</i>.'
+
+    # should we cache files changed? (recommended for large trees)
+    # this will be a folder containing one file.  if the folder doesn't
+    # exist, it'll be created.
+    #
+    # all branches in this project will share the same cache, which is usually
+    # what you want if they share a repository.  if not, you can also specify
+    # this per-branch.
+    cachepath = '/Users/robey/code/bzr/.bzr/loggerhead-files'
+
+    # each branch is in a sub-folder of the website, and the config
+    # key describes that folder name:
+    [[bzr.dev]]
+
+        # where is the bazaar branch located?
+        folder = '/Users/robey/code/bzr/bzr.dev'
+
+        # (optional) is there a friendier name for the branch that i should
+        # use on the web pages?
+        # you can also define this using the branch's nickname.
+        #branch_name = 'bazaar-dev'
+
+        # (optional) short description for the top-level page
+        # you can also define this using the "description" config key in the
+        # branch's 'branch.conf'.
+        description = "bazaar vcs development branch"
+
+        # (optional) public branch url for the top-level page
+        # you can also define this using the "public_url" config key in the
+        # branch's 'branch.conf'.
+        url = 'http://bazaar-ng.org/bzr/bzr.dev'
+
+
+# here's an example of an auto-published folder:
+[paramiko]
+    name = 'paramiko'
+    cachepath = '/Users/robey/code/paramiko/.bzr/loggerhead-files'
+
+    # if an auto_publish_folder is given, any bazaar branches discovered in
+    # that folder will be published.  using each branch's 'branch.conf' to
+    # provide optional descriptions and public urls is a nice way to avoid
+    # having to do much configuration here.
+    auto_publish_folder = '/Users/robey/code/paramiko'
+
+    # if all of the branches under an auto_publish_folder are exported to
+    # the same (base) public url, you can specify that url prefix here, and
+    # each discovered branch's public url will be generated.
+    url_prefix = 'http://www.example.com/code/paramiko'

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2011-03-24 03:40:33 +0000
+++ loggerhead/__init__.py	2010-11-11 03:30:43 +0000
@@ -22,7 +22,7 @@
 
 import pkg_resources
 
-__version__ = '1.18.1'
+__version__ = '1.18'
 required_bzrlib = (1, 17)
 
 pkg_resources.get_distribution('Paste>=1.6')

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2011-08-17 11:04:00 +0000
+++ loggerhead/apps/branch.py	2011-02-09 22:29:57 +0000
@@ -63,20 +63,23 @@
         self.use_cdn = use_cdn
 
     def get_history(self):
+        file_cache = None
         revinfo_disk_cache = None
         cache_path = self._config.get('cachepath', None)
         if cache_path is not None:
             # Only import the cache if we're going to use it.
             # This makes sqlite optional
             try:
-                from loggerhead.changecache import RevInfoDiskCache
+                from loggerhead.changecache import (
+                    FileChangeCache, RevInfoDiskCache)
             except ImportError:
                 self.log.debug("Couldn't load python-sqlite,"
                                " continuing without using a cache")
             else:
+                file_cache = FileChangeCache(cache_path)
                 revinfo_disk_cache = RevInfoDiskCache(cache_path)
         return History(
-            self.branch, self.graph_cache,
+            self.branch, self.graph_cache, file_cache=file_cache,
             revinfo_disk_cache=revinfo_disk_cache, cache_key=self.friendly_name)
 
     def url(self, *args, **kw):
@@ -133,7 +136,7 @@
     def public_branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
-    def lookup_app(self, environ):
+    def app(self, environ, start_response):
         # Check again if the branch is blocked from being served, this is
         # mostly for tests. It's already checked in apps/transport.py
         if self.branch.get_config().get_user_option('http_serve') == 'False':
@@ -160,20 +163,14 @@
             raise httpexceptions.HTTPMovedPermanently(
                 self.absolute_url('/changes'))
         if path == 'static':
-            return static_app
-        elif path == '+json':
-            environ['loggerhead.as_json'] = True
-            path = request.path_info_pop(environ)
+            return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)
         if cls is None:
             raise httpexceptions.HTTPNotFound()
-        return cls(self, self.get_history)
-
-    def app(self, environ, start_response):
         self.branch.lock_read()
         try:
             try:
-                c = self.lookup_app(environ)
+                c = cls(self, self.get_history)
                 return c(environ, start_response)
             except:
                 environ['exc_info'] = sys.exc_info()

=== added file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	1970-01-01 00:00:00 +0000
+++ loggerhead/apps/config.py	2011-02-11 22:10:56 +0000
@@ -0,0 +1,230 @@
+"""A server that uses a loggerhead.conf file.
+
+We recreate the branch discovery and url scheme of the old branchview
+code.  It's all a bit horrible really.
+"""
+
+import logging
+import os
+import posixpath
+
+import bzrlib.lru_cache
+
+try:
+    from bzrlib.util.configobj.configobj import ConfigObj
+except ImportError:
+    from configobj import ConfigObj
+
+from paste.request import path_info_pop
+from paste import httpexceptions
+from paste.wsgiwrappers import WSGIResponse
+
+from loggerhead.apps.branch import BranchWSGIApp
+from loggerhead.apps import favicon_app, static_app, robots_app
+from loggerhead.templatefunctions import templatefunctions
+from loggerhead.zptsupport import load_template
+from loggerhead import util
+
+log = logging.getLogger("loggerhead.controllers")
+
+from loggerhead.history import is_branch
+
+
+class Project(object):
+    """A project contains the branches.
+
+    There is some complication because we don't want to hold on to the
+    branches when they are not being browsed."""
+
+    def __init__(self, name, config, root_config, graph_cache):
+        self.name = name
+        self.friendly_name = config.get('name', name)
+        self.description = config.get('description', '')
+        self.long_description = config.get('long_description', '')
+        self._config = config
+        self._root_config = root_config
+        self.graph_cache = graph_cache
+
+        self.view_names = []
+        self.view_data_by_name = {}
+        for view_name in config.sections:
+            log.debug('Configuring (project %s) branch %s...', name, view_name)
+            self._add_view(
+                view_name, config[view_name], config[view_name].get('folder'))
+
+        self._auto_folder = config.get('auto_publish_folder', None)
+        self._auto_list = []
+        if self._auto_folder is not None:
+            self._recheck_auto_folders()
+
+    def _recheck_auto_folders(self):
+        if self._auto_folder is None:
+            return
+        auto_list = []
+        # scan a folder for bazaar branches, and add them automatically
+        for path, folders, filenames in os.walk(self._auto_folder):
+            for folder in folders:
+                folder = os.path.join(path, folder)
+                if is_branch(folder):
+                    auto_list.append(folder)
+        auto_list.sort()
+        if auto_list == self._auto_list:
+            # nothing has changed; do nothing.
+            return
+
+        # rebuild views:
+        self.view_names = []
+        log.debug('Rescanning auto-folder for project %s ...', self.name)
+        for folder in auto_list:
+            view_name = os.path.basename(folder)
+            log.debug('Auto-configuring (project %s) branch %s...',
+                      self.name,
+                      view_name)
+            self._add_view(view_name, ConfigObj(), folder)
+        self._auto_list = auto_list
+
+    def _get_branch_url(self, view, view_config, folder):
+        url = view_config.get('url', None)
+        if url is not None:
+            return url
+        url = self._config.get('url_prefix', None)
+        if url is not None:
+            return posixpath.join(url, folder) + '/'
+        return None
+
+    def _get_description(self, view, view_config, history):
+        description = view_config.get('description', None)
+        if description is not None:
+            return description
+        description = history._branch.get_config().get_user_option(
+                          'description')
+        return description
+
+    def _add_view(self, view_name, view_config, folder):
+        b = bzrlib.branch.Branch.open(folder)
+        view = BranchWSGIApp(b, view_name, view_config, self.graph_cache)
+        b.lock_read()
+        try:
+            history = view.get_history()
+            friendly_name = view_config.get('branch_name', None)
+            if friendly_name is None:
+                friendly_name = history.get_config().get_nickname()
+                if friendly_name is None:
+                    friendly_name = view_name
+            branch_url = self._get_branch_url(view, view_config, view_name)
+            description = self._get_description(view, view_config, history)
+            self.view_data_by_name[view_name] = {
+                'branch_path': folder,
+                'config': view_config,
+                'description': description,
+                'friendly_name': friendly_name,
+                'graph_cache': self.graph_cache,
+                'name': view_name,
+                'served_url': branch_url,
+                }
+            self.view_names.append(view_name)
+        finally:
+            b.unlock()
+
+    def view_named(self, name):
+        view_data = self.view_data_by_name.get(name)
+        if view_data is None:
+            return None
+        view_data = view_data.copy()
+        branch_path = view_data.pop('branch_path')
+        description = view_data.pop('description')
+        name = view_data.pop('name')
+        b = bzrlib.branch.Branch.open(branch_path)
+        b.lock_read()
+        view = BranchWSGIApp(b, **view_data)
+        view.description = description
+        view.name = name
+        return view
+
+    def call(self, environ, start_response):
+        segment = path_info_pop(environ)
+        if not segment:
+            raise httpexceptions.HTTPNotFound()
+        else:
+            view = self.view_named(segment)
+            if view is None:
+                raise httpexceptions.HTTPNotFound()
+            try:
+                return view.app(environ, start_response)
+            finally:
+                view.branch.unlock()
+
+
+class Root(object):
+    """The root of the server -- renders as the browse view,
+    dispatches to Project above for each 'project'."""
+
+    def __init__(self, config):
+        self.projects = []
+        self.config = config
+        self.projects_by_name = {}
+        graph_cache = bzrlib.lru_cache.LRUCache()
+        for project_name in self.config.sections:
+            project = Project(project_name, self.config[project_name],
+                              self.config, graph_cache)
+            self.projects.append(project)
+            self.projects_by_name[project_name] = project
+
+    def browse(self, response):
+        # This is insanely complicated because we want to open and
+        # lock all the branches, render the view and then unlock the
+        # branches again.
+        for p in self.projects:
+            p._recheck_auto_folders()
+
+        class branch(object):
+
+            @staticmethod
+            def static_url(path):
+                return self._static_url_base + path
+        views_by_project = {}
+        all_views = []
+        try:
+            for p in self.projects:
+                views_by_project[p] = []
+                for vn in p.view_names:
+                    v = p.view_named(vn)
+                    all_views.append(v)
+                    views_by_project[p].append(v)
+            vals = {
+                'projects': self.projects,
+                'util': util,
+                'title': self.config.get('title', None),
+                'branch': branch,
+                'views_by_project': views_by_project,
+            }
+            vals.update(templatefunctions)
+            response.headers['Content-Type'] = 'text/html'
+            template = load_template('loggerhead.templates.browse')
+            template.expand_into(response, **vals)
+        finally:
+            for v in all_views:
+                v.branch.unlock()
+
+    def __call__(self, environ, start_response):
+        self._static_url_base = environ['loggerhead.static.url'] = \
+                                environ['SCRIPT_NAME']
+        segment = path_info_pop(environ)
+        if segment is None:
+            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
+                environ['SCRIPT_NAME'] + '/', environ)
+        elif segment == '':
+            response = WSGIResponse()
+            self.browse(response)
+            return response(environ, start_response)
+        elif segment == 'robots.txt':
+            return robots_app(environ, start_response)
+        elif segment == 'static':
+            return static_app(environ, start_response)
+        elif segment == 'favicon.ico':
+            return favicon_app(environ, start_response)
+        else:
+            project = self.projects_by_name.get(segment)
+            if project is None:
+                raise httpexceptions.HTTPNotFound()
+            return project.call(environ, start_response)

=== removed file 'loggerhead/apps/http_head.py'
--- loggerhead/apps/http_head.py	2011-02-10 02:33:15 +0000
+++ loggerhead/apps/http_head.py	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-"""WSGI apps tend to return body content as part of a HEAD request.
-
-We should definitely not do that.
-"""
-
-class HeadMiddleware(object):
-    """When we get a HEAD request, we should not return body content.
-
-    WSGI defaults to just generating everything, and not paying attention to
-    whether it is a GET or a HEAD request. It does that because of potential
-    issues getting the Headers correct.
-
-    This middleware works by just omitting the body if the request method is
-    HEAD.
-    """
-
-    def __init__(self, app):
-        self._wrapped_app = app
-        self._real_environ = None
-        self._real_start_response = None
-        self._real_writer = None
-
-    def noop_write(self, chunk):
-        """We intentionally ignore all body content that is returned."""
-        pass
-
-    def start_response(self, status, response_headers, exc_info=None):
-        if exc_info is None:
-            self._real_writer = self._real_start_response(status,
-                response_headers)
-        else:
-            self._real_writer = self._real_start_response(status,
-                response_headers, exc_info)
-        return self.noop_write
-
-    def __call__(self, environ, start_response):
-        self._real_environ = environ
-        self._real_start_response = start_response
-        if environ.get('REQUEST_METHOD', 'GET') == 'HEAD':
-            result = self._wrapped_app(environ, self.start_response)
-            for chunk in result:
-                pass
-        else:
-            result = self._wrapped_app(environ, start_response)
-            for chunk in result:
-                yield chunk

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2011-03-16 14:43:36 +0000
+++ loggerhead/apps/transport.py	2010-05-05 18:35:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2011-08-17 11:04:00 +0000
+++ loggerhead/changecache.py	2009-05-02 14:01:05 +0000
@@ -99,6 +99,24 @@
             pass
 
 
+class FileChangeCache(object):
+
+    def __init__(self, cache_path):
+
+        if not os.path.exists(cache_path):
+            os.mkdir(cache_path)
+
+        self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
+
+    def get_file_changes(self, entry):
+        cache = FakeShelf(self._changes_filename)
+        changes = cache.get(entry.revid)
+        if changes is None:
+            changes = self.history.get_file_changes_uncached(entry)
+            cache.add(entry.revid, changes)
+        return changes
+
+
 class RevInfoDiskCache(object):
     """Like `RevInfoMemoryCache` but backed in a sqlite DB."""
 

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2010-05-12 14:38:05 +0000
+++ loggerhead/config.py	2010-04-13 23:35:01 +0000
@@ -49,12 +49,6 @@
     parser.add_option("--protocol", dest="protocol",
                       help=("Protocol to use: http, scgi, fcgi, ajp"
                            "(defaults to http)."))
-    parser.add_option("--log-level", default=None, action='callback',
-                      callback=_optparse_level_to_int_level,
-                      type="string",
-                      help="Set the verbosity of logging. Can either"
-                           " be set to a numeric or string"
-                           " (eg, 10=debug, 30=warning)")
     parser.add_option("--memory-profile", action="store_true",
                       help="Profile the memory usage using Dozer.")
     parser.add_option("--prefix", dest="user_prefix",
@@ -78,29 +72,6 @@
     return parser
 
 
-_log_levels = {
-    'debug': 10,
-    'info': 20,
-    'warning': 30,
-    'error': 40,
-    'critical': 50,
-}
-
-def _optparse_level_to_int_level(option, opt_str, value, parser):
-    parser.values.log_level = _level_to_int_level(value)
-
-
-def _level_to_int_level(value):
-    """Convert a string level to an integer value."""
-    if value is None:
-        return None
-    try:
-        return int(value)
-    except ValueError:
-        pass
-    return _log_levels[value.lower()]
-
-
 class LoggerheadConfig(object):
     """A configuration object."""
 
@@ -128,10 +99,6 @@
         else:
             return cmd_config
 
-    def get_log_level(self):
-        opt = self.get_option('log_level')
-        return _level_to_int_level(opt)
-
     def get_arg(self, index):
         """Get an arg from the arg list."""
         return self._args[index]

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-06-28 16:09:37 +0000
+++ loggerhead/controllers/__init__.py	2011-02-10 17:01:10 +0000
@@ -18,7 +18,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import bzrlib.errors
-import simplejson
 import time
 
 from paste.httpexceptions import HTTPNotFound
@@ -54,7 +53,6 @@
 class TemplatedBranchView(object):
 
     template_path = None
-    supports_json = False
 
     def __init__(self, branch, history_callable):
         self._branch = branch
@@ -69,7 +67,8 @@
         self.__history = self._history_callable()
         return self.__history
 
-    def parse_args(self, environ):
+    def __call__(self, environ, start_response):
+        z = time.time()
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
@@ -83,48 +82,33 @@
         if len(args) > 1:
             path = unicode('/'.join(args[1:]), 'utf-8')
         self.args = args
-        self.kwargs = kwargs
-        return path
 
-    def add_template_values(self, values):
-        values.update({
+        vals = {
             'static_url': self._branch.static_url,
             'branch': self._branch,
             'util': util,
             'url': self._branch.context_url,
-        })
-        values.update(templatefunctions)
-
-    def __call__(self, environ, start_response):
-        z = time.time()
-        if environ.get('loggerhead.as_json') and not self.supports_json:
-            raise HTTPNotFound
-        path = self.parse_args(environ)
+        }
+        vals.update(templatefunctions)
         headers = {}
-        values = self.get_values(path, self.kwargs, headers)
-
-        self.log.info('Getting information for %s: %.3f secs' % (
+
+        vals.update(self.get_values(path, kwargs, headers))
+
+        self.log.info('Getting information for %s: %r secs' % (
             self.__class__.__name__, time.time() - z))
-        if environ.get('loggerhead.as_json'):
-            headers['Content-Type'] = 'application/json'
-        elif 'Content-Type' not in headers:
+        if 'Content-Type' not in headers:
             headers['Content-Type'] = 'text/html'
         writer = start_response("200 OK", headers.items())
         if environ.get('REQUEST_METHOD') == 'HEAD':
             # No content for a HEAD request
             return []
+        template = load_template(self.template_path)
         z = time.time()
         w = BufferingWriter(writer, 8192)
-        if environ.get('loggerhead.as_json'):
-            w.write(simplejson.dumps(values,
-                default=util.convert_to_json_ready))
-        else:
-            self.add_template_values(values)
-            template = load_template(self.template_path)
-            template.expand_into(w, **values)
+        template.expand_into(w, **vals)
         w.flush()
         self.log.info(
-            'Rendering %s: %.3f secs, %s bytes' % (
+            'Rendering %s: %r secs, %s bytes' % (
                 self.__class__.__name__, time.time() - z, w.bytes))
         return []
 

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2011-08-09 14:06:49 +0000
+++ loggerhead/controllers/annotate_ui.py	2010-12-01 08:30:02 +0000
@@ -16,8 +16,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import itertools
-
 from loggerhead.controllers.view_ui import ViewUI
 from loggerhead import util
 
@@ -31,45 +29,23 @@
         
         change_cache = {}
         last_line_revid = None
-        last_lineno = None
-        message = ""
-
-        revisions = {}
-
-        lineno = 0
-        for (line_revid, text), lineno in zip(tree.annotate_iter(file_id), itertools.count(1)):
-            if line_revid != last_line_revid:
+        parity = 1
+        for line_revid, text in tree.annotate_iter(file_id):
+            if line_revid == last_line_revid:
+                # remember which lines have a new revno and which don't
+                new_rev = False
+            else:
+                new_rev = True
+                parity ^= 1
                 last_line_revid = line_revid
-
-                change = change_cache.get(line_revid, None)
-                if change is None:
+                if line_revid in change_cache:
+                    change = change_cache[line_revid]
+                else:
                     change = self._history.get_changes([line_revid])[0]
                     change_cache[line_revid] = change
 
-                try:
-                    message = change.comment.splitlines()[0]
-                except IndexError:
-                    # Comment not present for this revision
-                    message = ""
-
-                if last_lineno:
-                    # The revspan is of lines between the last revision and this one.
-                    # We set the one for the previous revision when we're creating the current revision.
-                    revisions[last_lineno].revspan = lineno - last_lineno
-
-                revisions[lineno] = util.Container(change=change, message=message)
-
-                last_lineno = lineno
-                last_line_revid = line_revid
-
-        # Zero-size file. Return empty revisions.
-        if last_lineno is None:
-            return revisions
-
-        # We never set a revspan for the last revision during the loop above, so set it here.
-        revisions[last_lineno].revspan = lineno - last_lineno + 1
-
-        return revisions
+            yield util.Container(
+                parity=parity, new_rev=new_rev, change=change)
             
     def get_values(self, path, kwargs, headers):
         values = super(AnnotateUI, self).get_values(path, kwargs, headers)

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2011-03-12 13:25:52 +0000
+++ loggerhead/controllers/changelog_ui.py	2011-03-02 14:07:21 +0000
@@ -47,8 +47,7 @@
 
         try:
             revid, start_revid, revid_list = history.get_view(
-                revid, start_revid, filter_file_id, query,
-                extra_rev_count=pagesize+1)
+                revid, start_revid, filter_file_id, query)
             util.set_context(kwargs)
 
             if (query is not None) and (len(revid_list) == 0):

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2011-06-28 16:51:55 +0000
+++ loggerhead/controllers/diff_ui.py	2010-04-08 01:08:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008  Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 #
 # This program is free software; you can redistribute it and/or modify
@@ -17,15 +17,17 @@
 #
 
 from cStringIO import StringIO
+import logging
 import time
 
 from paste.request import path_info_pop
 
 from bzrlib.diff import show_diff_trees
-from bzrlib.revision import NULL_REVISION
 
 from loggerhead.controllers import TemplatedBranchView
 
+log = logging.getLogger("loggerhead.controllers")
+
 
 class DiffUI(TemplatedBranchView):
     """Class to output a diff for a single file or revisions."""
@@ -47,10 +49,8 @@
         revid_from = self._history.fix_revid(revid_from)
         change = self._history.get_changes([revid_from])[0]
 
-        if len(args) == 2:
+        if len(args) is 2:
             revid_to = self._history.fix_revid(args[1])
-        elif len(change.parents) == 0:
-            revid_to = NULL_REVISION
         else:
             revid_to = change.parents[0].revid
 

=== modified file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2011-06-27 15:05:06 +0000
+++ loggerhead/controllers/filediff_ui.py	2009-07-07 23:52:24 +0000
@@ -77,7 +77,6 @@
 class FileDiffUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.filediff'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         revid = urllib.unquote(self.args[0])
@@ -88,5 +87,6 @@
             self._history._branch.repository, file_id, compare_revid, revid)
 
         return {
+            'util': util,
             'chunks': chunks,
         }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2011-06-27 16:30:57 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-19 00:44:05 +0000
@@ -22,7 +22,7 @@
 import posixpath
 import urllib
 
-from paste.httpexceptions import HTTPNotFound, HTTPMovedPermanently
+from paste.httpexceptions import HTTPNotFound
 
 from bzrlib import errors
 from bzrlib.revision import is_null as is_null_rev
@@ -31,6 +31,8 @@
 from loggerhead.controllers import TemplatedBranchView
 
 
+log = logging.getLogger("loggerhead.controllers")
+
 
 def dirname(path):
     if path is not None:
@@ -42,9 +44,8 @@
 class InventoryUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.inventory'
-    supports_json = True
 
-    def get_filelist(self, inv, path, sort_type, revno_url):
+    def get_filelist(self, inv, path, sort_type):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
@@ -57,9 +58,6 @@
         dir_ie = inv[file_id]
         file_list = []
 
-        if dir_ie.kind != 'directory':
-            raise HTTPMovedPermanently(self._branch.context_url(['/view', revno_url, path]))
-
         revid_set = set()
 
         for filename, entry in dir_ie.children.iteritems():
@@ -79,11 +77,6 @@
                 absolutepath = path + '/' + pathname
             revid = entry.revision
 
-            # TODO: For the JSON rendering, this inlines the "change" aka
-            # revision information attached to each file. Consider either
-            # pulling this out as a separate changes dict, or possibly just
-            # including the revision id and having a separate request to get
-            # back the revision info.
             file = util.Container(
                 filename=filename, executable=entry.executable,
                 kind=entry.kind, absolutepath=absolutepath,
@@ -116,6 +109,9 @@
         start_revid = kwargs.get('start_revid', None)
         sort_type = kwargs.get('sort', 'filename')
 
+        # no navbar for revisions
+        navigation = util.Container()
+
         if path is not None:
             path = path.rstrip('/')
             file_id = rev_tree.path2id(path)
@@ -136,7 +132,14 @@
         else:
             updir = dirname(path)
 
+        # Directory Breadcrumbs
+        directory_breadcrumbs = util.directory_breadcrumbs(
+                self._branch.friendly_name,
+                self._branch.is_root,
+                'files')
+
         if not is_null_rev(revid):
+
             change = history.get_changes([ revid ])[0]
             # If we're looking at the tip, use head: in the URL instead
             if revid == branch.last_revision():
@@ -144,49 +147,32 @@
             else:
                 revno_url = history.get_revno(revid)
             history.add_branch_nicks(change)
-            filelist = self.get_filelist(rev_tree.inventory, path, sort_type, revno_url)
 
+            # Create breadcrumb trail for the path within the branch
+            branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')
+            filelist = self.get_filelist(rev_tree.inventory, path, sort_type)
         else:
             start_revid = None
             change = None
             path = "/"
             updir = None
             revno_url = 'head:'
+            branch_breadcrumbs = []
             filelist = []
 
         return {
+            'branch': self._branch,
+            'util': util,
             'revid': revid,
             'revno_url': revno_url,
             'change': change,
             'path': path,
             'updir': updir,
             'filelist': filelist,
+            'navigation': navigation,
+            'url': self._branch.context_url,
             'start_revid': start_revid,
-        }
-
-    def add_template_values(self, values):
-        super(InventoryUI, self).add_template_values(values)
-        # Directory Breadcrumbs
-        directory_breadcrumbs = util.directory_breadcrumbs(
-                self._branch.friendly_name,
-                self._branch.is_root,
-                'files')
-
-        path = values['path']
-        revid = values['revid']
-        # no navbar for revisions
-        navigation = util.Container()
-
-        if is_null_rev(revid):
-            branch_breadcrumbs = []
-        else:
-            # Create breadcrumb trail for the path within the branch
-            branch = self._history._branch
-            rev_tree = branch.repository.revision_tree(revid)
-            branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')
-        values.update({
             'fileview_active': True,
             'directory_breadcrumbs': directory_breadcrumbs,
             'branch_breadcrumbs': branch_breadcrumbs,
-            'navigation': navigation,
-        })
+        }

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2011-09-02 09:43:57 +0000
+++ loggerhead/controllers/revision_ui.py	2011-03-02 14:07:21 +0000
@@ -36,7 +36,6 @@
 class RevisionUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revision'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         h = self._history
@@ -45,10 +44,9 @@
         filter_file_id = kwargs.get('filter_file_id', None)
         start_revid = h.fix_revid(kwargs.get('start_revid', None))
         query = kwargs.get('q', None)
+        remember = h.fix_revid(kwargs.get('remember', None))
         compare_revid = h.fix_revid(kwargs.get('compare_revid', None))
 
-        # TODO: This try/except looks to date before real exception handling
-        # and should be removed
         try:
             revid, start_revid, revid_list = h.get_view(revid,
                                                         start_revid,
@@ -57,13 +55,14 @@
         except:
             self.log.exception('Exception fetching changes')
             raise HTTPServerError('Could not fetch changes')
-        # XXX: Some concern about namespace collisions. These are only stored
-        # here so they can be expanded into the template later. Should probably
-        # be stored in a specific dict/etc.
-        self.revid_list = revid_list
-        self.compare_revid = compare_revid
-        self.path = path
-        kwargs['start_revid'] = start_revid
+
+        navigation = util.Container(
+            revid_list=revid_list, revid=revid, start_revid=start_revid,
+            filter_file_id=filter_file_id, pagesize=1,
+            scan_url='/revision', branch=self._branch, feed=True, history=h)
+        if query is not None:
+            navigation.query = query
+        util.fill_in_navigation(navigation)
 
         change = h.get_changes([revid])[0]
 
@@ -73,6 +72,24 @@
             file_changes = h.file_changes_for_revision_ids(
                 compare_revid, change.revid)
 
+        if path in ('', '/'):
+            path = None
+
+        link_data = {}
+        path_to_id = {}
+        if path:
+            item = [x for x in file_changes.text_changes if x.filename == path][0]
+            diff_chunks = diff_chunks_for_file(
+                self._history._branch.repository, item.file_id,
+                item.old_revision, item.new_revision)
+        else:
+            diff_chunks = None
+            for i, item in enumerate(file_changes.text_changes):
+                item.index = i
+                link_data['diff-' + str(i)] = '%s/%s/%s' % (
+                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
+                path_to_id[item.filename] = 'diff-' + str(i)
+
         h.add_branch_nicks(change)
 
         if '.' in change.revno:
@@ -87,53 +104,6 @@
         else:
             merged_in = None
 
-        return {
-            'revid': revid,
-            'change': change,
-            'file_changes': file_changes,
-            'merged_in': merged_in,
-        }
-
-    def add_template_values(self, values):
-        super(RevisionUI, self).add_template_values(values)
-        remember = self._history.fix_revid(self.kwargs.get('remember', None))
-        query = self.kwargs.get('q', None)
-        filter_file_id = self.kwargs.get('filter_file_id', None)
-        start_revid = self.kwargs['start_revid']
-        navigation = util.Container(
-            revid_list=self.revid_list, revid=values['revid'],
-            start_revid=start_revid,
-            filter_file_id=filter_file_id, pagesize=1,
-            scan_url='/revision', branch=self._branch, feed=True,
-            history=self._history)
-        if query is not None:
-            navigation.query = query
-        util.fill_in_navigation(navigation)
-        path = self.path
-        if path in ('', '/'):
-            path = None
-
-
-        file_changes = values['file_changes']
-        link_data = {}
-        path_to_id = {}
-        if path:
-            items = [x for x in file_changes.text_changes if x.filename == path]
-            if len(items) > 0:
-                item = items[0]
-                diff_chunks = diff_chunks_for_file(
-                    self._history._branch.repository, item.file_id,
-                    item.old_revision, item.new_revision)
-            else:
-                diff_chunks = None
-        else:
-            diff_chunks = None
-            for i, item in enumerate(file_changes.text_changes):
-                item.index = i
-                link_data['diff-' + str(i)] = '%s/%s/%s' % (
-                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
-                path_to_id[item.filename] = 'diff-' + str(i)
-
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -141,18 +111,25 @@
                 self._branch.is_root,
                 'changes'))
 
-        values.update({
-            'history': self._history,
+        return {
+            'branch': self._branch,
+            'revid': revid,
+            'change': change,
+            'file_changes': file_changes,
+            'diff_chunks': diff_chunks,
             'link_data': simplejson.dumps(link_data),
+            'specific_path': path,
             'json_specific_path': simplejson.dumps(path),
             'path_to_id': simplejson.dumps(path_to_id),
-            'directory_breadcrumbs': directory_breadcrumbs,
+            'start_revid': start_revid,
+            'filter_file_id': filter_file_id,
+            'util': util,
+            'history': h,
+            'merged_in': merged_in,
             'navigation': navigation,
+            'query': query,
             'remember': remember,
-            'compare_revid': self.compare_revid,
-            'filter_file_id': filter_file_id,
-            'diff_chunks': diff_chunks,
-            'query': query,
-            'specific_path': path,
-            'start_revid': start_revid,
-        })
+            'compare_revid': compare_revid,
+            'url': self._branch.context_url,
+            'directory_breadcrumbs': directory_breadcrumbs,
+        }

=== modified file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2011-06-27 15:05:06 +0000
+++ loggerhead/controllers/revlog_ui.py	2009-03-19 00:44:05 +0000
@@ -1,12 +1,12 @@
 import urllib
 
+from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
 
 
 class RevLogUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revlog'
-    supports_json = True
 
     def get_values(self, path, kwargs, headers):
         history = self._history
@@ -18,7 +18,10 @@
         history.add_branch_nicks(change)
 
         return {
+            'branch': self._branch,
             'entry': change,
             'file_changes': file_changes,
+            'util': util,
             'revid': revid,
+            'url': self._branch.context_url,
         }

=== modified file 'loggerhead/controllers/view_ui.py'
--- loggerhead/controllers/view_ui.py	2011-09-08 00:33:28 +0000
+++ loggerhead/controllers/view_ui.py	2010-12-01 08:30:02 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
 import time
 
@@ -24,7 +25,7 @@
 import bzrlib.textfile
 import bzrlib.osutils
 
-from paste.httpexceptions import HTTPBadRequest, HTTPServerError, HTTPMovedPermanently
+from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
 from loggerhead.controllers import TemplatedBranchView
 try:
@@ -64,7 +65,7 @@
             extra_lines = len(file_lines) - len(hl_lines)
             hl_lines.extend([u''] * extra_lines)
         else:
-            hl_lines = map(util.html_escape, file_lines)
+            hl_lines = map(cgi.escape, file_lines)
         
         return hl_lines;
 
@@ -119,14 +120,11 @@
             raise HTTPServerError('Could not fetch changes')
         branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
 
-        if inv[file_id].kind == "directory":
-            raise HTTPMovedPermanently(self._branch.context_url(['/files', revno_url, path]))
-
         return {
-            # In AnnotateUI, "annotated" is a dictionary mapping lines to changes.
-            # We exploit the fact that bool({}) is False when checking whether
-            # we're in "annotated" mode.
-            'annotated': {},
+            # In AnnotateUI, "annotated" is a generator giving revision
+            # numbers per lines, but the template checks if "annotated" is
+            # true or not before using it, so we have to define it here also.
+            'annotated': False,
             'revno_url': revno_url,
             'file_id': file_id,
             'file_path': path,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2011-08-17 11:04:00 +0000
+++ loggerhead/history.py	2010-05-10 13:48:25 +0000
@@ -1,4 +1,5 @@
-# Copyright (C) 2006-2011 Canonical Ltd.
+#
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
@@ -34,7 +35,6 @@
 import textwrap
 import threading
 
-from bzrlib import tag
 import bzrlib.branch
 import bzrlib.delta
 import bzrlib.errors
@@ -215,6 +215,8 @@
     around it, serve the request, throw the History object away, unlock the
     branch and throw it away.
 
+    :ivar _file_change_cache: An object that caches information about the
+        files that changed between two revisions.
     :ivar _rev_info: A list of information about revisions.  This is by far
         the most cryptic data structure in loggerhead.  At the top level, it
         is a list of 3-tuples [(merge-info, where-merged, parents)].
@@ -282,10 +284,15 @@
                 self._rev_indices[revid] = seq
                 self._revno_revid[revno_str] = revid
 
-    def __init__(self, branch, whole_history_data_cache,
+    def __init__(self, branch, whole_history_data_cache, file_cache=None,
                  revinfo_disk_cache=None, cache_key=None):
         assert branch.is_locked(), (
             "Can only construct a History object with a read-locked branch.")
+        if file_cache is not None:
+            self._file_change_cache = file_cache
+            file_cache.history = self
+        else:
+            self._file_change_cache = None
         self._branch = branch
         self._branch_tags = None
         self._inventory_cache = {}
@@ -320,16 +327,7 @@
         revid in revid_list.
         """
         if revid_list is None:
-            # Just yield the mainline, starting at start_revid
-            revid = start_revid
-            is_null = bzrlib.revision.is_null
-            while not is_null(revid):
-                yield revid
-                parents = self._rev_info[self._rev_indices[revid]][2]
-                if not parents:
-                    return
-                revid = parents[0]
-            return
+            revid_list = [r[0][1] for r in self._rev_info]
         revid_set = set(revid_list)
         revid = start_revid
 
@@ -342,14 +340,10 @@
                 r.add(self._rev_info[i][0][1])
                 i += 1
             return r
-        while revid_set:
+        while True:
             if bzrlib.revision.is_null(revid):
                 return
-            rev_introduced = introduced_revisions(revid)
-            matching = rev_introduced.intersection(revid_set)
-            if matching:
-                # We don't need to look for these anymore.
-                revid_set.difference_update(matching)
+            if introduced_revisions(revid) & revid_set:
                 yield revid
             parents = self._rev_info[self._rev_indices[revid]][2]
             if len(parents) == 0:
@@ -470,41 +464,15 @@
         if revid is None:
             revid = self.last_revid
         if file_id is not None:
-            revlist = list(
-                self.get_short_revision_history_by_fileid(file_id))
-            revlist = self.get_revids_from(revlist, revid)
+            # since revid is 'start_revid', possibly should start the path
+            # tracing from revid... FIXME
+            revlist = list(self.get_short_revision_history_by_fileid(file_id))
+            revlist = list(self.get_revids_from(revlist, revid))
         else:
-            revlist = self.get_revids_from(None, revid)
+            revlist = list(self.get_revids_from(None, revid))
         return revlist
 
-    @staticmethod
-    def _iterate_sufficiently(iterable, stop_at, extra_rev_count):
-        """Return a list of iterable.
-
-        If extra_rev_count is None, fully consume iterable.
-        Otherwise, stop at 'stop_at' + extra_rev_count.
-
-        Example:
-          iterate until you find stop_at, then iterate 10 more times.
-        """
-        if extra_rev_count is None:
-            return list(iterable)
-        result = []
-        found = False
-        for n in iterable:
-            result.append(n)
-            if n == stop_at:
-                found = True
-                break
-        if found:
-            for count, n in enumerate(iterable):
-                if count >= extra_rev_count:
-                    break
-                result.append(n)
-        return result
-
-    def get_view(self, revid, start_revid, file_id, query=None,
-                 extra_rev_count=None):
+    def get_view(self, revid, start_revid, file_id, query=None):
         """
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
@@ -515,10 +483,6 @@
               file.
             - if a start_revid is given, we're viewing the branch from a
               specific revision up the tree.
-            - if extra_rev_count is given, find the view from start_revid =>
-              revid, and continue an additional 'extra_rev_count'. If not
-              given, then revid_list will contain the full history of
-              start_revid
 
         these may be combined to view revisions for a specific file, from
         a specific revision, with a specific search query.
@@ -537,16 +501,12 @@
 
         if query is None:
             revid_list = self.get_file_view(start_revid, file_id)
-            revid_list = self._iterate_sufficiently(revid_list, revid,
-                                                    extra_rev_count)
             if revid is None:
                 revid = start_revid
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
                 revid_list = self.get_file_view(revid, file_id)
-                revid_list = self._iterate_sufficiently(revid_list, revid,
-                                                        extra_rev_count)
                 start_revid = revid
             return revid, start_revid, revid_list
 
@@ -710,21 +670,12 @@
 
         revtags = None
         if revision.revision_id in self._branch_tags:
-          # tag.sort_* functions expect (tag, data) pairs, so we generate them,
-          # and then strip them
-          tags = [(t, None) for t in self._branch_tags[revision.revision_id]]
-          sort_func = getattr(tag, 'sort_natural', None)
-          if sort_func is None:
-              tags.sort()
-          else:
-              sort_func(self._branch, tags)
-          revtags = u', '.join([t[0] for t in tags])
+          revtags = ', '.join(self._branch_tags[revision.revision_id])
 
         entry = {
             'revid': revision.revision_id,
             'date': datetime.datetime.fromtimestamp(revision.timestamp),
             'utc_date': datetime.datetime.utcfromtimestamp(revision.timestamp),
-            'committer': revision.committer,
             'authors': revision.get_apparent_authors(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
@@ -735,8 +686,7 @@
             'tags': revtags,
         }
         if isinstance(revision, bzrlib.foreign.ForeignRevision):
-            foreign_revid, mapping = (
-                revision.foreign_revid, revision.mapping)
+            foreign_revid, mapping = (rev.foreign_revid, rev.mapping)
         elif ":" in revision.revision_id:
             try:
                 foreign_revid, mapping = \
@@ -752,13 +702,19 @@
             entry["foreign_revid"] = mapping.vcs.show_foreign_revid(foreign_revid)
         return util.Container(entry)
 
-    def get_file_changes(self, entry):
+    def get_file_changes_uncached(self, entry):
         if entry.parents:
             old_revid = entry.parents[0].revid
         else:
             old_revid = bzrlib.revision.NULL_REVISION
         return self.file_changes_for_revision_ids(old_revid, entry.revid)
 
+    def get_file_changes(self, entry):
+        if self._file_change_cache is None:
+            return self.get_file_changes_uncached(entry)
+        else:
+            return self._file_change_cache.get_file_changes(entry)
+
     def add_changes(self, entry):
         changes = self.get_file_changes(entry)
         entry.changes = changes

=== modified file 'loggerhead/main.py'
--- loggerhead/main.py	2011-03-16 11:39:27 +0000
+++ loggerhead/main.py	2009-11-27 18:30:24 +0000
@@ -56,39 +56,21 @@
     return config, base
 
 
-def setup_logging(config, init_logging=True, log_file=None):
-    log_level = config.get_log_level()
-    if init_logging:
-        logging.basicConfig()
-        if log_level is not None:
-            logging.getLogger('').setLevel(log_level)
+def setup_logging(config):
+    logging.basicConfig()
+    logging.getLogger('').setLevel(logging.DEBUG)
     logger = logging.getLogger('loggerhead')
-    if log_level is not None:
-        logger.setLevel(log_level)
-    if log_file is not None:
-        handler = logging.StreamHandler(log_file)
+    if config.get_option('log_folder'):
+        logfile_path = os.path.join(
+            config.get_option('log_folder'), 'serve-branches.log')
     else:
-        if config.get_option('log_folder'):
-            logfile_path = os.path.join(
-                config.get_option('log_folder'), 'serve-branches.log')
-        else:
-            logfile_path = 'serve-branches.log'
-        handler = logging.FileHandler(logfile_path, 'a')
-        formatter = logging.Formatter('%(asctime)s %(levelname)-8s %(name)s:'
-                                      ' %(message)s')
-        handler.setFormatter(formatter)
-    # We set the handler to accept all messages, the *logger* won't emit them
-    # if it is configured to suppress it
-    handler.setLevel(logging.DEBUG)
-    logger.addHandler(handler)
-    def _restrict_logging(logger_name):
-        logger = logging.getLogger(logger_name)
-        if logger.getEffectiveLevel() < logging.INFO:
-            logger.setLevel(logging.INFO)
-    # simpleTAL is *very* verbose in DEBUG mode, which is otherwise the
-    # default. So quiet it up a bit.
-    _restrict_logging('simpleTAL')
-    _restrict_logging('simpleTALES')
+        logfile_path = 'serve-branches.log'
+    logfile = logging.FileHandler(logfile_path, 'a')
+    formatter = logging.Formatter('%(asctime)s %(levelname)-8s %(name)s:'
+                                  ' %(message)s')
+    logfile.setFormatter(formatter)
+    logfile.setLevel(logging.DEBUG)
+    logger.addHandler(logfile)
     return logger
 
 

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2011-04-22 17:22:49 +0000
+++ loggerhead/static/css/global.css	2011-02-24 00:44:09 +0000
@@ -152,7 +152,6 @@
     float: left;
     display: inline;
     height: 22px;
-    line-height: 22px;
     padding: 0 0 0 18px;
     background: transparent url(../images/ico_description.gif) no-repeat center left;
     }
@@ -164,6 +163,7 @@
     }
 
 #branch-info {
+    width: 900px;
     padding: 10px;
     margin: 0 0 10px 0;
     color: #666;

=== modified file 'loggerhead/static/css/view.css'
--- loggerhead/static/css/view.css	2011-04-22 17:22:26 +0000
+++ loggerhead/static/css/view.css	2011-02-18 05:41:17 +0000
@@ -1,30 +1,31 @@
 /*table*/
-#logentries,
+.viewLineTit,
+.viewRevTit,
+.viewContTit {
+    border: 1px solid #d2d2d2;
+    }
+.viewLine,
 .viewRev,
-.viewLine {
-    border: 1px solid #d2d2d2;
-}
-.viewRev {
-    border-right: none;
-    white-space: nowrap;
-    width: 1px;
-    padding: .3em .6em;
-}
 .viewComm,
 .viewCont {
     border: none;
     }
-.viewLine {
-    border-style: none solid none none;
-    width: 20px;
-    padding-left: .6em;
+.viewLine,
+.viewLineTit {
     padding-right: .2em;
     }
-.viewLine.first {
-    border-style: solid solid none none;
-}
+.viewLine {
+    width: 37px;
+    }
+.viewContTit,
 .viewCont {
-    padding-left: .4em;
+    width: auto;
+    padding-left: .3em;
+    }
+.viewRevTit,
+.viewRev {
+    width: 70px;
+    text-align: center;
     }
 .viewLine,
 .viewCont {
@@ -37,11 +38,6 @@
     margin: 0;
     }
 .viewLine {
-    text-align: center;
-    }
-.viewLine {
+    text-align: right;
     font-size: 93%;
     }
-.viewAuthors {
-    color: #999999;
-}

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2011-09-08 00:33:28 +0000
+++ loggerhead/templatefunctions.py	2011-03-02 14:07:21 +0000
@@ -14,8 +14,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
-import urllib
 
 import pkg_resources
 
@@ -23,7 +23,6 @@
 
 import loggerhead
 from loggerhead.zptsupport import zpt
-from loggerhead.util import html_format
 
 
 templatefunctions = {}
@@ -50,21 +49,16 @@
     if style == 'fragment':
         def file_link(filename):
             if currently_showing and filename == currently_showing:
-                return html_format(
-                    '<b><a href="#%s">%s</a></b>',
-                    urllib.quote(filename.encode('utf-8')), filename)
+                return '<b><a href="#%s">%s</a></b>' % (
+                    cgi.escape(filename), cgi.escape(filename))
             else:
                 return revision_link(
-                    url, entry.revno, filename,
-                    '#' + urllib.quote(filename.encode('utf-8')))
+                    url, entry.revno, filename, '#' + filename)
     else:
         def file_link(filename):
-            return html_format(
-                '<a href="%s%s" title="View changes to %s in revision %s">'
-                '%s</a>',
-                url(['/revision', entry.revno]),
-                '#' + urllib.quote(filename.encode('utf-8')),
-                filename, entry.revno, filename)
+            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
+                cgi.escape(entry.revno), cgi.escape(filename))
     return _pt('revisionfilechanges').expand(
         entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
 
@@ -128,16 +122,14 @@
 
 @templatefunc
 def view_link(url, revno, path):
-    return html_format(
-        '<a href="%s" title="Annotate %s">%s</a>',
-        url(['/view', revno, path]), path, path)
-
+    return '<a href="%s" title="Annotate %s">%s</a>' % (
+        url(['/view', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):
-    return html_format(
-        '<a href="%s%s" title="View changes to %s in revision %s">%s</a>',
-        url(['/revision', revno, path]), frag, path, revno, path)
+    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+        url(['/revision', revno, path]), frag, cgi.escape(path),
+        cgi.escape(revno), cgi.escape(path))
 
 
 @templatefunc

=== added file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/browse.pt	2011-02-17 19:51:25 +0000
@@ -0,0 +1,62 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+  <head>
+    <title>loggerhead branches</title>
+    <link rel="stylesheet"
+          tal:attributes="href python:branch.static_url('/static/css/global.css')" />
+    <link rel="shortcut icon"
+          tal:attributes="href python:branch.static_url('/static/images/favicon.ico')" />
+  </head>
+
+  <body>
+   <div id="loggerheadCont">
+    <div>
+      <div class="browse-project"
+           tal:repeat="project projects">
+        <h1 tal:content="project/friendly_name" />
+        <div class="browse-project-description"
+             tal:condition="python:len(project.long_description) > 0"
+             tal:content="structure project/long_description"></div>
+
+          <table id="logentries">
+            <tr class="logheader">
+              <th class="summarycell" colspan="2">Name</th>
+              <th class="summarycell">Description</th>
+              <th class="datecell" colspan="2">Last change</th>
+            </tr>
+            <tal:block repeat="view python:views_by_project[project]">
+              <tr tal:attributes="class string:blueRow1">
+                <td class="icocell">
+                  <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" alt="Branch" />
+                </td>
+                <td class="autcell">
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                       tal:content="view/friendly_name" />
+                </td>
+                <td class="autcell"
+                    tal:content="view/description" />
+                <td class="date"
+                    tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'" />
+                <td class="icocell">
+                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name + '/atom')"
+                     title="atom feed">
+                    <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')"
+                         alt="atom feed" />
+                  </a>
+                </td>
+              </tr>
+              <tr tal:condition="view/served_url">
+                <td class="name">
+                </td>
+                <td class="description url" colspan="2">
+                  <a tal:attributes="href view/served_url"
+                     tal:content="view/served_url" />
+                </td>
+              </tr>
+            </tal:block>
+          </table>
+      </div>
+    </div>
+  </div>
+  </body>
+</html>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2011-04-22 18:18:02 +0000
+++ loggerhead/templates/inventory.pt	2011-02-23 03:01:15 +0000
@@ -19,18 +19,22 @@
           </tal:has-link>
       </tal:block>
       <tal:block metal:fill-slot="branchname" tal:content="string:${branch/friendly_name}" />
-          <tal:block metal:fill-slot="heading">
-          <div id="breadcrumbs">
+      <tal:block metal:fill-slot="heading">
+      <div id="breadcrumbs">
           <tal:has-link condition="branch/branch_link">
             <a tal:attributes="href branch/branch_link"
                tal:content="branch/friendly_name">
               nice/branch/name
             </a>
           </tal:has-link>
-          <tal:no-link condition="not: branch/branch_link">
-            <span metal:use-macro="breadcrumbs/directory"></span>
-          </tal:no-link>
-          <span>: <span metal:use-macro="breadcrumbs/branch" /> (revision <tal:revno content="change/revno"></tal:revno>)</span>
+          <span tal:condition="not: branch/branch_link">
+            <span metal:use-macro="breadcrumbs/directory" />
+          </span>
+          <tal:block condition="python:change">
+            &#187; Viewing
+            <span metal:use-macro="breadcrumbs/branch" />
+            for revision <span tal:content="change/revno"/>
+          </tal:block>
         </div>
       </tal:block>
 

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2011-06-28 16:51:55 +0000
+++ loggerhead/templates/revision.pt	2011-02-23 03:01:15 +0000
@@ -80,7 +80,7 @@
             </a>
           </li>
           <li>
-            <a tal:condition="python:compare_revid is None"
+            <a tal:condition="python:len(change.parents) > 0 and compare_revid is None"
                tal:attributes="href python:url(['/diff', change.revno], clear=1)">download diff</a>
             <a tal:condition="python:compare_revid is not None"
                tal:attributes="href python:url(['/diff', change.revno, history.get_revno(compare_revid)], clear=1)">download diff</a>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2011-03-16 12:37:17 +0000
+++ loggerhead/templates/revisioninfo.pt	2011-02-18 05:41:17 +0000
@@ -3,10 +3,6 @@
         <ul>
             <li class="committer">
                 <strong>Committer:</strong>
-                <span tal:content="python:util.hide_email(change.committer)"></span>
-            </li>
-            <li class="authors" tal:condition="python:len(change.authors) > 1 or change.authors[0] != change.committer">
-                <strong>Author(s):</strong>
                 <span tal:content="python:', '.join(util.hide_emails(change.authors))"></span>
             </li>
             <li class="timer">

=== modified file 'loggerhead/templates/view.pt'
--- loggerhead/templates/view.pt	2011-04-22 17:22:26 +0000
+++ loggerhead/templates/view.pt	2011-02-23 03:01:15 +0000
@@ -49,11 +49,11 @@
             </li>
             <li tal:condition="not:annotated">
               <a tal:attributes="href python:url(['/annotate', revno_url, file_path], clear=1)"
-              >view with revision information</a>
+              >view revision numbers per line</a>
             </li>
             <li tal:condition="annotated">
               <a tal:attributes="href python:url(['/view', revno_url, file_path], clear=1)"
-              >view without revision information</a>
+              >view without revision numbers</a>
             </li>
             <li>
                 <a tal:attributes="href python:url(['/revision', change.revno], clear=1)">view revision</a>
@@ -71,23 +71,24 @@
 
       <div class="view">
         <table id="logentries">
+          <tr class="logheader">
+            <th class="viewLineTit">Line</th>
+            <th class="viewRevTit" tal:condition="annotated">Revision</th>
+            <th class="viewContTit">Contents</th>
+          </tr>
+
           <tal:rep tal:repeat="line contents">
-            <tr>
-              <td tal:condition="python:path('repeat/line/number') in annotated"
-                  tal:define="anno python:annotated.get(path('repeat/line/number'), None)"
-                  tal:attributes="rowspan python:anno.revspan"
-                  class="viewRev">
-                <a tal:content="python:'%s' % (anno.change.revno,)"
+            <tr tal:define="anno python:annotated and annotated.next()"
+                tal:attributes="class python:anno and 'blueRow' + str(anno.parity) or None">
+              <td class="viewLine">
+                <a tal:attributes="id string:L${repeat/line/number}; href string:#L${repeat/line/number}"
+                   tal:content="repeat/line/number">1</a>
+              </td>
+              <td class="viewRev" tal:condition="annotated">
+                <a tal:condition="python:anno.new_rev"
+                   tal:content="python:util.trunc(anno.change.revno)"
                    tal:attributes="href python:url(['/revision', anno.change.revno], clear=1);
                                    title python:'%s by %s, on %s (%s)' % (anno.change.revno, ', '.join(util.hide_emails(anno.change.authors)), anno.change.date.strftime('%d %b %Y %H:%M'), util.date_time(anno.change.date))"></a>
-                <span class="viewAuthors" tal:content="python:'by ' + ', '.join(util.hide_emails(anno.change.authors))" />
-                <br />
-
-                <span tal:content="python:anno.message"></span>
-              </td>
-              <td tal:attributes="class python:path('repeat/line/number') in annotated and 'viewLine first' or 'viewLine'">
-                <a tal:attributes="id string:L${repeat/line/number}; href string:#L${repeat/line/number}"
-                   tal:content="repeat/line/number">1</a>
               </td>
               <td class="viewCont"><pre tal:content="structure line"></pre></td>
             </tr>

=== modified file 'loggerhead/tests/__init__.py'
--- loggerhead/tests/__init__.py	2011-09-08 00:33:28 +0000
+++ loggerhead/tests/__init__.py	2011-02-10 23:06:59 +0000
@@ -20,12 +20,8 @@
         (__name__ + '.' + x) for x in [
             'test_controllers',
             'test_corners',
-            'test_history',
-            'test_http_head',
             'test_load_test',
             'test_simple',
-            'test_revision_ui',
             'test_templating',
-            'test_util',
         ]]))
     return standard_tests

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-09-02 09:43:08 +0000
+++ loggerhead/tests/test_controllers.py	2011-02-10 17:01:10 +0000
@@ -1,39 +1,58 @@
-import simplejson
+from cStringIO import StringIO
+import logging
+
+from paste.httpexceptions import HTTPServerError
+
+from bzrlib import errors
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.controllers.annotate_ui import AnnotateUI
 from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.tests.test_simple import BasicTests, consume_app
+from loggerhead.tests.test_simple import BasicTests
 from loggerhead import util
 
 
 class TestInventoryUI(BasicTests):
 
-    def make_bzrbranch_for_tree_shape(self, shape):
+    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape):
         tree = self.make_branch_and_tree('.')
         self.build_tree(shape)
         tree.smart_add([])
         tree.commit('')
-        self.addCleanup(tree.branch.lock_read().unlock)
-        return tree.branch
+        tree.branch.lock_read()
+        self.addCleanup(tree.branch.unlock)
+        branch_app = BranchWSGIApp(tree.branch, '')
+        branch_app.log.setLevel(logging.CRITICAL)
+        # These are usually set in BranchWSGIApp.app(), which is set from env
+        # settings set by BranchesFromTransportRoot, so we fake it.
+        branch_app._static_url_base = '/'
+        branch_app._url_base = '/'
+        return tree.branch, InventoryUI(branch_app, branch_app.get_history)
 
-    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape):
-        branch = self.make_bzrbranch_for_tree_shape(shape)
-        branch_app = self.make_branch_app(branch)
-        return branch, InventoryUI(branch_app, branch_app.get_history)
+    def consume_app(self, app, extra_environ=None):
+        env = {'SCRIPT_NAME': '/files', 'PATH_INFO': ''}
+        if extra_environ is not None:
+            env.update(extra_environ)
+        body = StringIO()
+        start = []
+        def start_response(status, headers, exc_info=None):
+            start.append((status, headers, exc_info))
+            return body.write
+        extra_content = list(app(env, start_response))
+        body.writelines(extra_content)
+        return start[0], body.getvalue()
 
     def test_get_filelist(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
         inv = bzrbranch.repository.get_inventory(bzrbranch.last_revision())
-        self.assertEqual(1, len(inv_ui.get_filelist(inv, '', 'filename', 'head')))
+        self.assertEqual(1, len(inv_ui.get_filelist(inv, '', 'filename')))
 
     def test_smoke(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': ''})
+        start, content = self.consume_app(inv_ui)
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertContainsRe(content, 'filename')
@@ -41,86 +60,43 @@
     def test_no_content_for_HEAD(self):
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
             ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': '',
-             'REQUEST_METHOD': 'HEAD'})
+        start, content = self.consume_app(inv_ui,
+                            extra_environ={'REQUEST_METHOD': 'HEAD'})
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertEqual('', content)
 
-    def test_get_values_smoke(self):
-        branch = self.make_bzrbranch_for_tree_shape(['a-file'])
-        branch_app = self.make_branch_app(branch)
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/files'}
-        inv_ui = branch_app.lookup_app(env)
-        inv_ui.parse_args(env)
-        values = inv_ui.get_values('', {}, {})
-        self.assertEqual('a-file', values['filelist'][0].filename)
-
-    def test_json_render_smoke(self):
-        branch = self.make_bzrbranch_for_tree_shape(['a-file'])
-        branch_app = self.make_branch_app(branch)
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/files'}
-        inv_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(inv_ui, env)
-
 
 class TestRevisionUI(BasicTests):
 
-    def make_branch_app_for_revision_ui(self, shape1, shape2):
+    def make_bzrbranch_and_revision_ui_for_tree_shapes(self, shape1, shape2):
         tree = self.make_branch_and_tree('.')
         self.build_tree_contents(shape1)
         tree.smart_add([])
-        tree.commit('msg 1', rev_id='rev-1')
+        tree.commit('')
         self.build_tree_contents(shape2)
         tree.smart_add([])
-        tree.commit('msg 2', rev_id='rev-2')
-        branch = tree.branch
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
+        tree.commit('')
+        tree.branch.lock_read()
+        self.addCleanup(tree.branch.unlock)
+        branch_app = BranchWSGIApp(tree.branch)
+        branch_app._environ = {
+            'wsgi.url_scheme':'',
+            'SERVER_NAME':'',
+            'SERVER_PORT':'80',
+            }
+        branch_app._url_base = ''
+        branch_app.friendly_name = ''
+        return tree.branch, RevisionUI(branch_app, branch_app.get_history)
 
     def test_get_values(self):
-        branch_app = self.make_branch_app_for_revision_ui([], [])
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/revision/2'}
-        rev_ui = branch_app.lookup_app(env)
-        rev_ui.parse_args(env)
-        self.assertIsInstance(rev_ui.get_values('', {}, []), dict)
-
-    def test_add_template_values(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n')], [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/revision/1/non-existent-file',
-               'QUERY_STRING':'start_revid=1' }
-        revision_ui = branch_app.lookup_app(env)
-        path = revision_ui.parse_args(env)
-        values = revision_ui.get_values(path, revision_ui.kwargs, {})
-        revision_ui.add_template_values(values)
-        self.assertIs(values['diff_chunks'], None)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n'), ('other-file', 'other\n')],
-                [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/revision/head:'}
-        revision_ui = branch_app.lookup_app(env)
-        revision_ui.parse_args(env)
-        values = revision_ui.get_values('', {}, {})
-
-        self.assertEqual(values['revid'], 'rev-2')
-        self.assertEqual(values['change'].comment, 'msg 2')
-        self.assertEqual(values['file_changes'].modified[0].filename, 'file')
-        self.assertEqual(values['merged_in'], None)
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_revision_ui(
-                [('file', 'content\n'), ('other-file', 'other\n')],
-                [('file', 'new content\n')])
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/revision/head:'}
-        revision_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(revision_ui, env)
-
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [], [])
+        rev_ui.args = ['2']
+        util.set_context({})
+        self.assertIsInstance(
+            rev_ui.get_values('', {}, []),
+            dict)
 
 
 class TestAnnotateUI(BasicTests):
@@ -129,107 +105,23 @@
         tree = self.make_branch_and_tree('.')
         self.build_tree_contents([('filename', '')])
         tree.add(['filename'], [file_id])
-        for rev_id, text, message in rev_ids_texts:
+        for rev_id, text in rev_ids_texts:
             self.build_tree_contents([('filename', text)])
-            tree.commit(rev_id=rev_id, message=message)
+            tree.commit(rev_id=rev_id, message='.')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
         branch_app = BranchWSGIApp(tree.branch, friendly_name='test_name')
         return AnnotateUI(branch_app, branch_app.get_history)
 
     def test_annotate_file(self):
-        history = [('rev1', 'old\nold\n', '.'), ('rev2', 'new\nold\n', '.')]
+        history = [('rev1', 'old\nold\n'), ('rev2', 'new\nold\n')]
         ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
         # A lot of this state is set up by __call__, but we'll do it directly
         # here.
         ann_ui.args = ['rev2']
         annotate_info = ann_ui.get_values('filename',
             kwargs={'file_id': 'file_id'}, headers={})
-        annotated = annotate_info['annotated']
+        annotated = list(annotate_info['annotated'])
         self.assertEqual(2, len(annotated))
-        self.assertEqual('2', annotated[1].change.revno)
-        self.assertEqual('1', annotated[2].change.revno)
-
-    def test_annotate_empty_comment(self):
-        # Testing empty comment handling without breaking
-        history = [('rev1', 'old\nold\n', '.'), ('rev2', 'new\nold\n', '')]
-        ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        ann_ui.args = ['rev2']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-
-    def test_annotate_file_zero_sized(self):
-        # Test against a zero-sized file without breaking. No annotation must be present.
-        history = [('rev1', '' , '.')]
-        ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        ann_ui.args = ['rev1']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-        annotated = annotate_info['annotated']
-        self.assertEqual(0, len(annotated))
-
-class TestFileDiffUI(BasicTests):
-
-    def make_branch_app_for_filediff_ui(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1-id', None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('filename', 'f-id', 'file', 'content\n'))],
-            message="First commit.")
-        builder.build_snapshot('rev-2-id', None, [
-            ('modify', ('f-id', 'new content\n'))])
-        builder.finish_series()
-        branch = builder.get_branch()
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_filediff_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+filediff/rev-2-id/rev-1-id/f-id'}
-        filediff_ui = branch_app.lookup_app(env)
-        filediff_ui.parse_args(env)
-        values = filediff_ui.get_values('', {}, {})
-        chunks = values['chunks']
-        self.assertEqual('insert', chunks[0].diff[1].type)
-        self.assertEqual('new content', chunks[0].diff[1].line)
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_filediff_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+json/+filediff/rev-2-id/rev-1-id/f-id'}
-        filediff_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(filediff_ui, env)
-
-
-class TestRevLogUI(BasicTests):
-
-    def make_branch_app_for_revlog_ui(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-id', None, [
-            ('add', ('', 'root-id', 'directory', '')),
-            ('add', ('filename', 'f-id', 'file', 'content\n'))],
-            message="First commit.")
-        builder.finish_series()
-        branch = builder.get_branch()
-        self.addCleanup(branch.lock_read().unlock)
-        return self.make_branch_app(branch)
-
-    def test_get_values_smoke(self):
-        branch_app = self.make_branch_app_for_revlog_ui()
-        env = {'SCRIPT_NAME': '/',
-               'PATH_INFO': '/+revlog/rev-id'}
-        revlog_ui = branch_app.lookup_app(env)
-        revlog_ui.parse_args(env)
-        values = revlog_ui.get_values('', {}, {})
-        self.assertEqual(values['file_changes'].added[1].filename, 'filename')
-        self.assertEqual(values['entry'].comment, "First commit.")
-
-    def test_json_render_smoke(self):
-        branch_app = self.make_branch_app_for_revlog_ui()
-        env = {'SCRIPT_NAME': '', 'PATH_INFO': '/+json/+revlog/rev-id'}
-        revlog_ui = branch_app.lookup_app(env)
-        self.assertOkJsonResponse(revlog_ui, env)
-
+        self.assertEqual('2', annotated[0].change.revno)
+        self.assertEqual('1', annotated[1].change.revno)

=== removed file 'loggerhead/tests/test_history.py'
--- loggerhead/tests/test_history.py	2011-03-25 13:09:10 +0000
+++ loggerhead/tests/test_history.py	1970-01-01 00:00:00 +0000
@@ -1,328 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""Direct tests of the loggerhead/history.py module"""
-
-from bzrlib.foreign import (
-    ForeignRevision,
-    ForeignVcs,
-    VcsMapping,
-    )
-
-from datetime import datetime
-from bzrlib import tag, tests
-
-from loggerhead import history as _mod_history
-
-
-class TestCaseWithExamples(tests.TestCaseWithMemoryTransport):
-
-    def make_linear_ancestry(self):
-        # Time goes up
-        # rev-3
-        #  |
-        # rev-2
-        #  |
-        # rev-1
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('rev-2', ['rev-1'], [])
-        builder.build_snapshot('rev-3', ['rev-2'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_long_linear_ancestry(self):
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('A', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        for r in "BCDEFGHIJKLMNOPQRSTUVWXYZ":
-            builder.build_snapshot(r, None, [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_merged_ancestry(self):
-        # Time goes up
-        # rev-3
-        #  |  \
-        #  |  rev-2
-        #  |  /
-        # rev-1
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('rev-1', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('rev-2', ['rev-1'], [])
-        builder.build_snapshot('rev-3', ['rev-1', 'rev-2'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def make_deep_merged_ancestry(self):
-        # Time goes up
-        # F
-        # |\
-        # | E
-        # | |\
-        # | | D
-        # | |/
-        # B C
-        # |/
-        # A
-        builder = self.make_branch_builder('branch')
-        builder.start_series()
-        builder.build_snapshot('A', None, [
-            ('add', ('', 'root-id', 'directory', None))])
-        builder.build_snapshot('B', ['A'], [])
-        builder.build_snapshot('C', ['A'], [])
-        builder.build_snapshot('D', ['C'], [])
-        builder.build_snapshot('E', ['C', 'D'], [])
-        builder.build_snapshot('F', ['B', 'E'], [])
-        builder.finish_series()
-        b = builder.get_branch()
-        self.addCleanup(b.lock_read().unlock)
-        return _mod_history.History(b, {})
-
-    def assertRevidsFrom(self, expected, history, search_revs, tip_rev):
-        self.assertEqual(expected,
-                         list(history.get_revids_from(search_revs, tip_rev)))
-
-
-class _DictProxy(object):
-
-    def __init__(self, d):
-        self._d = d
-        self._accessed = set()
-        self.__setitem__ = d.__setitem__
-
-    def __getitem__(self, name):
-        self._accessed.add(name)
-        return self._d[name]
-
-    def __len__(self):
-        return len(self._d)
-
-
-def track_rev_info_accesses(h):
-    """Track __getitem__ access to History._rev_info,
-
-    :return: set of items accessed
-    """
-    h._rev_info = _DictProxy(h._rev_info)
-    return h._rev_info._accessed
-
-
-class TestHistoryGetRevidsFrom(TestCaseWithExamples):
-
-    def test_get_revids_from_simple_mainline(self):
-        history = self.make_linear_ancestry()
-        self.assertRevidsFrom(['rev-3', 'rev-2', 'rev-1'],
-                              history, None, 'rev-3')
-
-    def test_get_revids_from_merged_mainline(self):
-        history = self.make_merged_ancestry()
-        self.assertRevidsFrom(['rev-3', 'rev-1'],
-                              history, None, 'rev-3')
-
-    def test_get_revids_given_one_rev(self):
-        history = self.make_merged_ancestry()
-        # rev-3 was the first mainline revision to see rev-2.
-        self.assertRevidsFrom(['rev-3'], history, ['rev-2'], 'rev-3')
-
-    def test_get_revids_deep_ancestry(self):
-        history = self.make_deep_merged_ancestry()
-        self.assertRevidsFrom(['F'], history, ['F'], 'F')
-        self.assertRevidsFrom(['F'], history, ['E'], 'F')
-        self.assertRevidsFrom(['F'], history, ['D'], 'F')
-        self.assertRevidsFrom(['F'], history, ['C'], 'F')
-        self.assertRevidsFrom(['B'], history, ['B'], 'F')
-        self.assertRevidsFrom(['A'], history, ['A'], 'F')
-
-    def test_get_revids_doesnt_over_produce_simple_mainline(self):
-        # get_revids_from shouldn't walk the whole ancestry just to get the
-        # answers for the first few revisions.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        result = history.get_revids_from(None, 'Z')
-        self.assertEqual(set(), accessed)
-        self.assertEqual('Z', result.next())
-        # We already know 'Z' because we passed it in.
-        self.assertEqual(set(), accessed)
-        self.assertEqual('Y', result.next())
-        self.assertEqual(set([history._rev_indices['Z']]), accessed)
-
-    def test_get_revids_doesnt_over_produce_for_merges(self):
-        # get_revids_from shouldn't walk the whole ancestry just to get the
-        # answers for the first few revisions.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        result = history.get_revids_from(['X', 'V'], 'Z')
-        self.assertEqual(set(), accessed)
-        self.assertEqual('X', result.next())
-        # We access 'W' because we are checking that W wasn't merged into X.
-        # The important bit is that we aren't getting the whole ancestry.
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXW']),
-                         accessed)
-        self.assertEqual('V', result.next())
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-        self.assertRaises(StopIteration, result.next)
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-
-
-
-class TestHistoryChangeFromRevision(tests.TestCaseWithTransport):
-
-    def make_single_commit(self):
-        tree = self.make_branch_and_tree('test')
-        rev_id = tree.commit('Commit Message', timestamp=1299838474.317,
-            timezone=3600, committer='Joe Example <joe@example.com>',
-            revprops={})
-        self.addCleanup(tree.branch.lock_write().unlock)
-        rev = tree.branch.repository.get_revision(rev_id)
-        history = _mod_history.History(tree.branch, {})
-        return history, rev
-
-    def test_simple(self):
-        history, rev = self.make_single_commit()
-        change = history._change_from_revision(rev)
-        self.assertEqual(rev.revision_id, change.revid)
-        self.assertEqual(datetime.fromtimestamp(1299838474.317),
-                         change.date)
-        self.assertEqual(datetime.utcfromtimestamp(1299838474.317),
-                         change.utc_date)
-        self.assertEqual(['Joe Example <joe@example.com>'],
-                         change.authors)
-        self.assertEqual('test', change.branch_nick)
-        self.assertEqual('Commit Message', change.short_comment)
-        self.assertEqual('Commit Message', change.comment)
-        self.assertEqual(['Commit&nbsp;Message'], change.comment_clean)
-        self.assertEqual([], change.parents)
-        self.assertEqual([], change.bugs)
-        self.assertEqual(None, change.tags)
-
-    def test_tags(self):
-        history, rev = self.make_single_commit()
-        b = history._branch
-        b.tags.set_tag('tag-1', rev.revision_id)
-        b.tags.set_tag('tag-2', rev.revision_id)
-        b.tags.set_tag('Tag-10', rev.revision_id)
-        change = history._change_from_revision(rev)
-        # If available, tags are 'naturally' sorted. (sorting numbers in order,
-        # and ignoring case, etc.)
-        if getattr(tag, 'sort_natural', None) is not None:
-            self.assertEqual('tag-1, tag-2, Tag-10', change.tags)
-        else:
-            self.assertEqual('Tag-10, tag-1, tag-2', change.tags)
-
-    def test_committer_vs_authors(self):
-        tree = self.make_branch_and_tree('test')
-        rev_id = tree.commit('Commit Message', timestamp=1299838474.317,
-            timezone=3600, committer='Joe Example <joe@example.com>',
-            revprops={'authors': u'A Author <aauthor@example.com>\n'
-                                 u'B Author <bauthor@example.com>'})
-        self.addCleanup(tree.branch.lock_write().unlock)
-        rev = tree.branch.repository.get_revision(rev_id)
-        history = _mod_history.History(tree.branch, {})
-        change = history._change_from_revision(rev)
-        self.assertEqual(u'Joe Example <joe@example.com>',
-                         change.committer)
-        self.assertEqual([u'A Author <aauthor@example.com>',
-                          u'B Author <bauthor@example.com>'],
-                         change.authors)
-
-
-class TestHistory_IterateSufficiently(tests.TestCase):
-
-    def assertIterate(self, expected, iterable, stop_at, extra_rev_count):
-        self.assertEqual(expected, _mod_history.History._iterate_sufficiently(
-            iterable, stop_at, extra_rev_count))
-
-    def test_iter_no_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(['a', 'b', 'c'], iter(lst), 'c', 0)
-        self.assertIterate(['a', 'b', 'c', 'd'], iter(lst), 'd', 0)
-
-    def test_iter_not_found(self):
-        # If the key in question isn't found, we just exhaust the list
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'not-there', 0)
-
-    def test_iter_with_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(['a', 'b', 'c'], iter(lst), 'b', 1)
-        self.assertIterate(['a', 'b', 'c', 'd', 'e'], iter(lst), 'c', 2)
-
-    def test_iter_with_too_many_extra(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'y', 10)
-        self.assertIterate(lst, iter(lst), 'z', 10)
-
-    def test_iter_with_extra_None(self):
-        lst = list('abcdefghijklmnopqrstuvwxyz')
-        self.assertIterate(lst, iter(lst), 'z', None)
-
-
-
-class TestHistoryGetView(TestCaseWithExamples):
-
-    def test_get_view_limited_history(self):
-        # get_view should only load enough history to serve the result, not all
-        # history.
-        history = self.make_long_linear_ancestry()
-        accessed = track_rev_info_accesses(history)
-        revid, start_revid, revid_list = history.get_view('Z', 'Z', None,
-                                                      extra_rev_count=5)
-        self.assertEqual(['Z', 'Y', 'X', 'W', 'V', 'U'], revid_list)
-        self.assertEqual('Z', revid)
-        self.assertEqual('Z', start_revid)
-        self.assertEqual(set([history._rev_indices[x] for x in 'ZYXWVU']),
-                         accessed)
-
-
-class TestHistoryGetChangedUncached(TestCaseWithExamples):
-
-    def test_native(self):
-        history = self.make_linear_ancestry()
-        changes = history.get_changes_uncached(['rev-1', 'rev-2'])
-        self.assertEquals(2, len(changes))
-        self.assertEquals('rev-1', changes[0].revid)
-        self.assertEquals('rev-2', changes[1].revid)
-        self.assertIs(None, getattr(changes[0], 'foreign_vcs', None))
-        self.assertIs(None, getattr(changes[0], 'foreign_revid', None))
-
-    def test_foreign(self):
-        # Test with a mocked foreign revision, as it's not possible
-        # to rely on any foreign plugins being installed.
-        history = self.make_linear_ancestry()
-        foreign_vcs = ForeignVcs(None, "vcs")
-        foreign_vcs.show_foreign_revid = repr
-        foreign_rev = ForeignRevision(("uuid", 1234), VcsMapping(foreign_vcs),
-            "revid-in-bzr", message="message",
-            timestamp=234423423.3)
-        change = history._change_from_revision(foreign_rev)
-        self.assertEquals('revid-in-bzr', change.revid)
-        self.assertEquals("('uuid', 1234)", change.foreign_revid)
-        self.assertEquals("vcs", change.foreign_vcs)

=== removed file 'loggerhead/tests/test_http_head.py'
--- loggerhead/tests/test_http_head.py	2011-02-10 02:33:15 +0000
+++ loggerhead/tests/test_http_head.py	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Tests for the HeadMiddleware app."""
-
-from cStringIO import StringIO
-
-from bzrlib import tests
-
-from loggerhead.apps import http_head
-
-
-content = ["<html>",
-           "<head><title>Listed</title></head>",
-           "<body>Content</body>",
-           "</html>",
-          ]
-headers = {'X-Ignored-Header': 'Value'}
-
-def yielding_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    for chunk in content:
-        yield chunk
-
-
-def list_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    return content
-
-
-def writer_app(environ, start_response):
-    writer = start_response('200 OK', headers)
-    for chunk in content:
-        writer(chunk)
-    return []
-
-
-class TestHeadMiddleware(tests.TestCase):
-
-    def _trap_start_response(self, status, response_headers, exc_info=None):
-        self._write_buffer = StringIO()
-        self._start_response_passed = (status, response_headers, exc_info)
-        return self._write_buffer.write
-
-    def _consume_app(self, app, request_method):
-        environ = {'REQUEST_METHOD': request_method}
-        value = list(app(environ, self._trap_start_response))
-        self._write_buffer.writelines(value)
-
-    def _verify_get_passthrough(self, app):
-        app = http_head.HeadMiddleware(app)
-        self._consume_app(app, 'GET')
-        self.assertEqual(('200 OK', headers, None), self._start_response_passed)
-        self.assertEqualDiff(''.join(content), self._write_buffer.getvalue())
-
-    def _verify_head_no_body(self, app):
-        app = http_head.HeadMiddleware(app)
-        self._consume_app(app, 'HEAD')
-        self.assertEqual(('200 OK', headers, None), self._start_response_passed)
-        self.assertEqualDiff('', self._write_buffer.getvalue())
-
-    def test_get_passthrough_yielding(self):
-        self._verify_get_passthrough(yielding_app)
-
-    def test_head_passthrough_yielding(self):
-        self._verify_head_no_body(yielding_app)
-
-    def test_get_passthrough_list(self):
-        self._verify_get_passthrough(list_app)
-
-    def test_head_passthrough_list(self):
-        self._verify_head_no_body(list_app)
-
-    def test_get_passthrough_writer(self):
-        self._verify_get_passthrough(writer_app)
-
-    def test_head_passthrough_writer(self):
-        self._verify_head_no_body(writer_app)
-

=== modified file 'loggerhead/tests/test_load_test.py'
--- loggerhead/tests/test_load_test.py	2011-04-14 14:10:04 +0000
+++ loggerhead/tests/test_load_test.py	2011-02-10 00:49:06 +0000
@@ -20,7 +20,7 @@
 from bzrlib import tests
 from bzrlib.tests import http_server
 
-from loggerhead import load_test
+from bzrlib.plugins.loggerhead.loggerhead import load_test
 
 
 empty_script = """{
@@ -286,7 +286,7 @@
         self.build_tree(['first', 'second', 'third', 'fourth'])
         url = self.get_readonly_url()
         script = load_test.ActionScript.parse("""{
-            "parameters": {"base_url": "%s", "blocking_timeout": 2.0},
+            "parameters": {"base_url": "%s", "blocking_timeout": 0.1},
             "requests": [
                 {"thread": "1", "relpath": "first"},
                 {"thread": "2", "relpath": "second"},

=== removed file 'loggerhead/tests/test_revision_ui.py'
--- loggerhead/tests/test_revision_ui.py	2011-03-16 12:37:17 +0000
+++ loggerhead/tests/test_revision_ui.py	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-# Copyright (C) 2011 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-
-from loggerhead.tests.test_simple import BasicTests
-
-
-class TestRevisionUI(BasicTests):
-
-    def test_authors_vs_committer(self):
-        self.createBranch()
-        self.tree.commit('First', committer="Joe Example <joe@example.com>",
-            revprops={'authors': u'A Author <aauthor@example.com>\n'
-                                 u'B Author <bauthor@example.com>'})
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        # We would like to assert that Joe Example is connected to Committer,
-        # and the Authors are connected. However, that requires asserting the
-        # exact HTML connections, which I wanted to avoid.
-        res.mustcontain('Committer', 'Joe Example',
-                        'Author(s)', 'A Author, B Author')
-
-    def test_author_is_committer(self):
-        self.createBranch()
-        self.tree.commit('First', committer="Joe Example <joe@example.com>")
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        # We would like to assert that Joe Example is connected to Committer,
-        # and the Authors are connected. However, that requires asserting the
-        # exact HTML connections, which I wanted to avoid.
-        res.mustcontain('Committer', 'Joe Example')
-        self.assertFalse('Author(s)' in res.body)

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2011-09-08 00:33:28 +0000
+++ loggerhead/tests/test_simple.py	2011-02-12 13:25:20 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009, 2011 Canonical Ltd.
+# Copyright (C) 2007-2011 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,8 +18,6 @@
 import cgi
 import logging
 import re
-import simplejson
-from cStringIO import StringIO
 
 from bzrlib.tests import TestCaseWithTransport
 try:
@@ -29,10 +27,17 @@
 from bzrlib import config
 
 from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps.http_head import HeadMiddleware
 from paste.fixture import TestApp
-from paste.httpexceptions import HTTPExceptionHandler, HTTPMovedPermanently
-
+from paste.httpexceptions import HTTPExceptionHandler
+
+
+
+def test_config_root():
+    from loggerhead.apps.config import Root
+    config = ConfigObj()
+    app = TestApp(HTTPExceptionHandler(Root(config)))
+    res = app.get('/')
+    res.mustcontain('loggerhead branches')
 
 
 class BasicTests(TestCaseWithTransport):
@@ -49,23 +54,6 @@
         branch_app = BranchWSGIApp(self.tree.branch, '', **kw).app
         return TestApp(HTTPExceptionHandler(branch_app))
 
-    def assertOkJsonResponse(self, app, env):
-        start, content = consume_app(app, env)
-        self.assertEqual('200 OK', start[0])
-        self.assertEqual('application/json', dict(start[1])['Content-Type'])
-        self.assertEqual(None, start[2])
-        simplejson.loads(content)
-
-    def make_branch_app(self, branch):
-        branch_app = BranchWSGIApp(branch, friendly_name='friendly-name')
-        branch_app._environ = {
-            'wsgi.url_scheme':'',
-            'SERVER_NAME':'',
-            'SERVER_PORT':'80',
-            }
-        branch_app._url_base = ''
-        return branch_app
-
 
 class TestWithSimpleTree(BasicTests):
 
@@ -75,11 +63,9 @@
 
         self.filecontents = ('some\nmultiline\ndata\n'
                              'with<htmlspecialchars\n')
-        filenames = ['myfilename', 'anotherfile<']
         self.build_tree_contents(
-            (filename, self.filecontents) for filename in filenames)
-        for filename in filenames:
-            self.tree.add(filename, '%s-id' % filename)
+            [('myfilename', self.filecontents)])
+        self.tree.add('myfilename', 'myfile-id')
         self.fileid = self.tree.path2id('myfilename')
         self.msg = 'a very exciting commit message <'
         self.revid = self.tree.commit(message=self.msg)
@@ -91,7 +77,7 @@
 
     def test_changes_for_file(self):
         app = self.setUpLoggerhead()
-        res = app.get('/changes?filter_file_id=myfilename-id')
+        res = app.get('/changes?filter_file_id=myfile-id')
         res.mustcontain(cgi.escape(self.msg))
 
     def test_changes_branch_from(self):
@@ -152,8 +138,6 @@
     def test_revision(self):
         app = self.setUpLoggerhead()
         res = app.get('/revision/1')
-        res.mustcontain(no=['anotherfile<'])
-        res.mustcontain('anotherfile&lt;')
         res.mustcontain('myfilename')
 
 
@@ -194,71 +178,6 @@
         res = app.get('/changes', status=404)
 
 
-class TestControllerRedirects(BasicTests):
-    """
-    Test that a file under /files redirects to /view,
-    and a directory under /view redirects to /files.
-    """
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.build_tree(('file', 'folder/', 'folder/file'))
-        self.tree.smart_add([])
-        self.tree.commit('')
-
-    def test_view_folder(self):
-        app = TestApp(BranchWSGIApp(self.tree.branch, '').app)
-
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/view/head:/folder')
-        self.assertEqual(e.location(), '/files/head:/folder')
-
-    def test_files_file(self):
-        app = TestApp(BranchWSGIApp(self.tree.branch, '').app)
-
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/files/head:/folder/file')
-        self.assertEqual(e.location(), '/view/head:/folder/file')
-        e = self.assertRaises(HTTPMovedPermanently, app.get, '/files/head:/file')
-        self.assertEqual(e.location(), '/view/head:/file')
-
-
-class TestHeadMiddleware(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.msg = 'trivial commit message'
-        self.revid = self.tree.commit(message=self.msg)
-
-    def setUpLoggerhead(self, **kw):
-        branch_app = BranchWSGIApp(self.tree.branch, '', **kw).app
-        return TestApp(HTTPExceptionHandler(HeadMiddleware(branch_app)))
-
-    def test_get(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes')
-        res.mustcontain(self.msg)
-        self.assertEqual('text/html', res.header('Content-Type'))
-
-    def test_head(self):
-        app = self.setUpLoggerhead()
-        res = app.get('/changes', extra_environ={'REQUEST_METHOD': 'HEAD'})
-        self.assertEqual('text/html', res.header('Content-Type'))
-        self.assertEqualDiff('', res.body)
-
-
-def consume_app(app, env):
-    body = StringIO()
-    start = []
-    def start_response(status, headers, exc_info=None):
-        start.append((status, headers, exc_info))
-        return body.write
-    extra_content = list(app(env, start_response))
-    body.writelines(extra_content)
-    return start[0], body.getvalue()
-
-
-
 #class TestGlobalConfig(BasicTests):
 #    """
 #    Test that global config settings are respected

=== removed file 'loggerhead/tests/test_util.py'
--- loggerhead/tests/test_util.py	2011-09-08 00:33:28 +0000
+++ loggerhead/tests/test_util.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import tests
-
-from loggerhead.util import html_escape, html_format
-
-
-class TestHTMLEscaping(tests.TestCase):
-
-    def test_html_escape(self):
-        self.assertEqual(
-            "foo &quot;&#39;&lt;&gt;&amp;",
-            html_escape("foo \"'<>&"))
-
-    def test_html_format(self):
-        self.assertEqual(
-            '<foo bar="baz&quot;&#39;">&lt;baz&gt;&amp;</foo>',
-            html_format(
-                '<foo bar="%s">%s</foo>', "baz\"'", "<baz>&"))

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2011-09-08 00:33:28 +0000
+++ loggerhead/util.py	2010-04-28 21:41:32 +0000
@@ -20,6 +20,7 @@
 #
 
 import base64
+import cgi
 import datetime
 import logging
 import re
@@ -213,47 +214,16 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
-# Can't be a dict; &amp; needs to be done first.
-html_entity_subs = [
-    ("&", "&amp;"),
-    ('"', "&quot;"),
-    ("'", "&#39;"), # &apos; is defined in XML, but not HTML.
-    (">", "&gt;"),
-    ("<", "&lt;"),
-    ]
-
-
-def html_escape(s):
-    """Transform dangerous (X)HTML characters into entities.
-
-    Like cgi.escape, except also escaping " and '. This makes it safe to use
-    in both attribute and element content.
-
-    If you want to safely fill a format string with escaped values, use
-    html_format instead
-    """
-    for char, repl in html_entity_subs:
-        s = s.replace(char, repl)
-    return s
-
-
-def html_format(template, *args):
-    """Safely format an HTML template string, escaping the arguments.
-
-    The template string must not be user-controlled; it will not be escaped.
-    """
-    return template % tuple(html_escape(arg) for arg in args)
-
-
 # FIXME: get rid of this method; use fixed_width() and avoid XML().
 
+
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
     entities, and replace spaces with '&nbsp;'.  this is primarily for use
     in displaying monospace text.
     """
-    s = html_escape(s.expandtabs())
+    s = cgi.escape(s.expandtabs())
     s = s.replace(' ', '&nbsp;')
     return s
 
@@ -299,7 +269,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = html_escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 
@@ -663,13 +633,3 @@
             else:
                 raise
     return new_application
-
-
-def convert_to_json_ready(obj):
-    if isinstance(obj, Container):
-        d = obj.__dict__.copy()
-        del d['_properties']
-        return d
-    elif isinstance(obj, datetime.datetime):
-        return tuple(obj.utctimetuple())
-    raise TypeError(repr(obj) + " is not JSON serializable")

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2010-04-26 19:37:26 +0000
+++ loggerhead/wholehistory.py	2009-10-21 14:40:23 +0000
@@ -80,6 +80,6 @@
             if revid not in c[1]:
                 c[1] = c[1] + (revid,)
 
-    log.info('built revision graph cache: %.3f secs' % (time.time() - z,))
+    log.info('built revision graph cache: %r secs' % (time.time() - z,))
 
     return (_rev_info, _rev_indices)

=== modified file 'loggerhead/zptsupport.py'
--- loggerhead/zptsupport.py	2010-05-12 15:01:44 +0000
+++ loggerhead/zptsupport.py	2009-03-02 05:44:20 +0000
@@ -23,6 +23,10 @@
 
 from simpletal import simpleTAL, simpleTALES
 
+logging.getLogger("simpleTAL").setLevel(logging.INFO)
+logging.getLogger("simpleTALES").setLevel(logging.INFO)
+
+
 _zpt_cache = {}
 
 

=== modified file 'setup.py'
--- setup.py	2011-03-10 14:22:12 +0000
+++ setup.py	2010-05-13 22:18:07 +0000
@@ -65,5 +65,6 @@
                                    "static/images/*"]},
     data_files = [
         ('share/man/man1', ['serve-branches.1']),
+        ('share/doc/loggerhead', ['loggerhead.conf.example']),
         ],
     )

